//
//  ChatPresenter.swift
//  VKExt
//
//  Created programmist_NA on 31.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import RealmSwift
import SwiftyJSON

class ChatPresenter: ChatPresenterProtocol {
    weak private var view: ChatViewProtocol?
    var interactor: ChatInteractorProtocol?
    private let router: ChatWireframeProtocol
    let realm = try! Realm()

    init(interface: ChatViewProtocol, interactor: ChatInteractorProtocol?, router: ChatWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }

    func start(offset: Int, peerId: Int, count: Int) {
        guard let interactor = self.interactor else { return }
        interactor.start(offset: offset, peerId: peerId, count: count)
    }
    
    func onError(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.2, execute: {
            self.onEvent(message: message, style)
        })
    }
    
    func onEvent(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
            // self.view?.showStatusError(message: message, error: nil, style)
        })
    }

    func onSendMessage(message: String, peerId: Int, randomId: Int64) {
        guard let interactor = interactor else { return }
        interactor.sendMessage(message: message, peerId: peerId, randomId: randomId)
    }
    
    func onDeleteMessage(messageId: Int, removeFromAll: Bool) {
        guard let interactor = interactor else { return }
        interactor.removeMessage(messageId: messageId, removeFromAll: removeFromAll)
    }
    
    func onEditMessage(message: String, messageId: Int, peerId: Int) {
        guard let interactor = interactor else { return }
        interactor.edit(message: message, messageId: messageId, peerId: peerId)
    }
    
    var messagesCount: Int {
        get {
            let messages = realm.objects(Message.self).sorted(byKeyPath: "dateInt", ascending: false).filter("peerId == %@", self.view!.peerId!)
            guard messages.count != 0 else { return 0 }
            return messages.count
        }
    }
}
